; AILang generated workspace; entry: list
source_filename = "list.ail"
target triple = "<NORMALIZED>"

@.str_list_fmt_int_0 = private unnamed_addr constant [6 x i8] c"%lld\0A\00", align 1

declare i32 @printf(ptr, ...)
declare i32 @puts(ptr)
declare ptr @GC_malloc(i64)
declare i32 @strcmp(ptr, ptr)
declare zeroext i1 @ail_str_eq(ptr, ptr)
declare i32 @ail_str_compare(ptr, ptr)
declare i64 @llvm.fptosi.sat.i64.f64(double)

@ail_list_sum_list_clos = private unnamed_addr constant { ptr, ptr } { ptr @ail_list_sum_list_adapter, ptr null }
@ail_list_main_clos = private unnamed_addr constant { ptr, ptr } { ptr @ail_list_main_adapter, ptr null }
define i64 @ail_list_sum_list(ptr %arg_xs) {
entry:
  %v1 = load i64, ptr %arg_xs, align 8
  switch i64 %v1, label %mdefault.2 [
    i64 0, label %marm.2.0
    i64 1, label %marm.2.1
  ]
marm.2.0:
  br label %mjoin.2
marm.2.1:
  %v3 = getelementptr inbounds i8, ptr %arg_xs, i64 8
  %v4 = load i64, ptr %v3, align 8
  %v5 = getelementptr inbounds i8, ptr %arg_xs, i64 16
  %v6 = load ptr, ptr %v5, align 8
  %v7 = call i64 @ail_list_sum_list(ptr %v6)
  %v8 = add i64 %v4, %v7
  br label %mjoin.2
mdefault.2:
  unreachable
mjoin.2:
  %v9 = phi i64 [ 0, %marm.2.0 ], [ %v8, %marm.2.1 ]
  ret i64 %v9
}

define i64 @ail_list_sum_list_adapter(ptr %_env, ptr %a0) {
entry:
  %r = call i64 @ail_list_sum_list(ptr %a0)
  ret i64 %r
}

define i8 @ail_list_main() {
entry:
  %v1 = call ptr @GC_malloc(i64 8)
  store i64 0, ptr %v1, align 8
  %v2 = call ptr @GC_malloc(i64 24)
  store i64 1, ptr %v2, align 8
  %v3 = getelementptr inbounds i8, ptr %v2, i64 8
  store i64 12, ptr %v3, align 8
  %v4 = getelementptr inbounds i8, ptr %v2, i64 16
  store ptr %v1, ptr %v4, align 8
  %v5 = call ptr @GC_malloc(i64 24)
  store i64 1, ptr %v5, align 8
  %v6 = getelementptr inbounds i8, ptr %v5, i64 8
  store i64 20, ptr %v6, align 8
  %v7 = getelementptr inbounds i8, ptr %v5, i64 16
  store ptr %v2, ptr %v7, align 8
  %v8 = call ptr @GC_malloc(i64 24)
  store i64 1, ptr %v8, align 8
  %v9 = getelementptr inbounds i8, ptr %v8, i64 8
  store i64 10, ptr %v9, align 8
  %v10 = getelementptr inbounds i8, ptr %v8, i64 16
  store ptr %v5, ptr %v10, align 8
  %v11 = call i64 @ail_list_sum_list(ptr %v8)
  call i32 (ptr, ...) @printf(ptr @.str_list_fmt_int_0, i64 %v11)
  ret i8 0
}

define i8 @ail_list_main_adapter(ptr %_env) {
entry:
  %r = call i8 @ail_list_main()
  ret i8 %r
}


define i32 @main() {
  call i8 @ail_list_main()
  ret i32 0
}
